
///////////////////////////////////////////////////////////////////////////////
//

// Reference to the WRTKit user interface manager and main view.
var uiManager;
var screenWidth = window.innerWidth;
var feedName = null;
var feedURL = null;
var feedUpdateFrequencyStatic = 1000 * 60 * 30;
var feedUpdateFrequency = feedUpdateFrequencyStatic;
var currentChannel = 0;
// Feed update broker.
var adUpdate = null;
var verChecker = null;
var appUpdateUrl=null;
var appUpdateVer=null;
var adUpdateStart=0;
var isWide = false;
var sendSite=true;
// adsTypes : 0 - one ad for feedUpdate, 1- one ad for each story
var adsType = 0;
var isInMiniView = false;
var emptyView;
var isWidget = false;
var running = false;
var adnum=0;
var adsHTML=[];
var adTime=300;    // initialised ready to go - will not make ad request less than this time
var lastAdDownload = 0;
var currentAd=0;
var adUrl = "http://"+domain+"/link/nokia-ads.jsp?id="+mippinID+"&adnum=";
var imei;
var helper = Helper;
var isFirstTimeUse = true;
var channelTitles =[];
var channelCount=1;
var channels = new Array(4);
var lastTopMain =0;
var lastTopStory =0;
var lastChannelCount=1;
var lastChannelId=0;
var channelsToUpdate= new Array(4);
var widgetOb = new WidgetOb();
// vibra duration in millis
var vibraDuration = 50;
// vibra intense from -100 to 100
var vibraIntense = 15;
var initFinished=false;
var rtol=false; //right to left

var galleryTimerActive = false;



// Called from the onload event handler to initialize the widget.
function init(){
	window.menu.hideSoftkeys();
	
    var doc = document;
    /// container
    /*bill*/
	//getE("headerImg", doc).alt = mippinTitle;
	getE('activeItem', doc).innerHTML=mippinTitle;
    getE('SmsText', doc).innerHTML=sms;
	getE('EmailText', doc).innerHTML=email;
	getE('ShareBoxTitle',doc).innerHTML=articleBox;
	
	if(ucc=='cn')
	{
		getE('TwitterText', doc).onclick='';
		getE('FacebookText', doc).onclick='';
	}else
	{
		getE('TwitterText', doc).innerHTML=twitter;
		getE('FacebookText', doc).innerHTML=facebook;
	}

	//decide if this is a right to left language
	if(language=='ar' || (language=='he') || (language=='ur') || (language=='fa'))
	{
		rtol=true;
	}

	if (rtol) {
		document.body.setAttribute('dir', 'rtl');
		getE("HeaderContainer").className="rtol";
		getE("miniViewLoading").className="rtol";
	}
	
    imei = window.widget.preferenceForKey(mippinID+"_imei"); 
	if (imei==null){
    
	   	try
	 	{
	 		var systemServiceObj = device.getServiceObject("Service.SysInfo", "ISysInfo");
	 		var criteria = new Object();
	 	    criteria.Entity = "Device";
	 	    criteria.Key = "IMEI";
	 	    var result = systemServiceObj.ISysInfo.GetInfo(criteria);
	 	    imei = result.ReturnValue.StringData
	 	   window.widget.setPreferenceForKey(imei,mippinID+"_imei"); 
	 	} catch (ex) {
	 		
	 	}
    }
  
 	if (imei==null) {
 		var rand_no = Math.random();
 		rand_no = rand_no * 100;
 		imei = new Date().getTime()+'_'+rand_no
 		window.widget.setPreferenceForKey(imei,mippinID+"_imei"); 
 	}
 	
    loadPreferences();
     
    if (helper.isMiniViewMode()) {
		isInMiniView = true;
		isWidget = true;
	}

    // create UI manager
    uiManager = new UIManager();
    emptyView = new View(null);
		//do auto update
	var	stopUpdateCheck = window.widget.preferenceForKey('stop_update_checks');
    if(!isInMiniView && (stopUpdateCheck==null || stopUpdateCheck!='1'))
	{
		versionCheck(true);
	}else
	{
		initContinue();
	}
}

function initContinue(){
	initFinished=true;
	setupChannels();
	currentChannel = 0;
    channels[0] = new Channel(0,widgetOb);
    if (isWidget) {
		initWidget();
    }
    else {
       channels[0].showMainView();
    }

	setTimeout(updateFeedTimerFunc, 200);
	// start feed update timer (called once every second)
    updateTimerId = setInterval(updateFeedTimerFunc, 10000);
}
function WidgetOb(){

}

function doOnAnyAction(){
	if (pTimer) {
		window.clearTimeout(pTimer);
		pTimer = null;
	}
	
	/*bill*/
	//hideAbout();
	//hideUpdateNow();
	hideShareBox();
	hideVeil();
	dropDownClose();
	if(!initFinished) initContinue();
}

// Timer function for feed updates - called once every 10 seconds.
function updateFeedTimerFunc(){

    if (running) {
        channels[0].changeStoryHomeView();
    }
    channels[0].updateContent();
}



function runOvi(){
	doOnAnyAction();
	var hasApp = false;
	var so = device.getServiceObject("Service.AppManager", "IAppManager");
    var criteria = new Object();
  	criteria.Type = 'Application';
	try {
	    var result = so.IAppManager.GetList(criteria);
	    var iterator = result.ReturnValue;
		var item;
       	iterator.reset();
		while ((item = iterator.getNext()) != undefined) {
            try {
				if (item.Uid == null) 
					continue;
			} catch (e1){
				continue;
			}
			var uid = item.Uid;
			if (uid == '0x2001a93d' || uid == '0x2002d07f'){
				hasApp=true;
				break;
			}
			
        }
		if (!hasApp) {
			criteria.Type = 'UserInstalledPackage';
			result = so.IAppManager.GetList(criteria);
		    iterator = result.ReturnValue;
			iterator.reset();
		   while ((item = iterator.getNext()) != undefined) {
	           try {
					if (item.Uid == null) 
						continue;
				} catch (e1){
					continue;
				}
				var uid = item.Uid;
				if (uid == '0x2001a93d' || uid == '0x2002d07f'){
					hasApp=true;
					break;
				}
				
	        }
	}
		
		
	  }
	  catch (e) {
	   hasApp = false;
	  }
	if (hasApp) {
		try {
			var ua = navigator.userAgent;
			ua = ua.toLowerCase();
			var newDev = "series60\/5.2";
			if (ua.match(newDev))
				window.widget.openApplication(0x2002d07f, '');	
			else
				window.widget.openApplication(0x2001a93d, '');

			return;
		} catch (e2) {
//			alert("error :"+e2);
		}
	}
	window.widget.openURL('http://store.ovi.mobi/?cid=ovistore-fw-bac-na-acq-na-ovi-g0-na-1');
}
WidgetOb.prototype.checkOrientation = function(){
    if (isInMiniView) return;
	if (channels!=null && channels[currentChannel].isUpdating && channels[currentChannel].isMainView()) showWaiterWithoutFlag();
	var doc = document;
    var win = window;
	var inHeight = win.innerHeight;
	var inWidth = win.innerWidth;
		


		
	/*bill*/
	var tmpTitle = "";
	if(typeof(channelTitles[currentChannel]) == 'undefined')
		tmpTitle = mippinTitle;
	else
		tmpTitle = channelTitles[currentChannel];
	
	var ai = getE('activeItem', doc);
    var buf = "<a href=\"#\" id=\"activeItema\" onClick=\"dropDownToggle(); return false\">"+tmpTitle+"</a>";
	ai.innerHTML=buf;

	if ((lastChannelCount!=channelCount) || lastChannelId!=currentChannel) {
		/*var ai = getE('activeItem', doc);
        var buf = "<a href=\"#\" id=\"activeItema\" onClick=\"dropDownToggle(); return false\">"+channelTitles[currentChannel]+"</a>";
		ai.innerHTML=buf;*/

		
		var il = getE('itemList', doc);
        var buf = "<ul>";
		for (var i=0; i<channelCount; i++) {
			if (i == currentChannel)
				buf = buf+"<li>\
				<div id='dropdownSelectedBg'>\
					<a href=\"javascript:refresh()\" style='float:left'><img src='imagesNew/refresh_icon_New.png'/></a>\
					<a href=\"javascript:refresh()\"><span style='padding-right:15px'>"+channelTitles[i]+"</span></a></li>\
				</div>";
			else
				buf = buf+"<li><a style='margin-left:34px' href=\"javascript:showChannel("+i+")\"><span style='padding-right:15px'>"+channelTitles[i]+"</span></a></li>";
				
		}
		buf = buf+"</ul>";    
		il.innerHTML=buf;
		lastChannelCount = channelCount;
		lastChannelId = currentChannel;
		landscapeToggle(isWide);
	}
	
	
    if (inWidth != screenWidth || isFirstTimeUse) {
		isFirstTimeUse = false;
		screenWidth = inWidth;
       	var n = getE('NotificationPopup',doc);
		n.style.top = (inHeight/2 - n.style.height/2)+"px";
        n.style.left = (inWidth/2 - n.style.width/2)+"px";
    
		var phoneFrame = getE('phoneFrame');
	    phoneFrame.style.width = inWidth;
		landscapeToggle(isWide);
    }
	var help = helper;
	var isEmptyView = false;
	var ch = channels[currentChannel];
	if (uiManager.getView() == emptyView) isEmptyView = true;
	if (uiManager.getView() == ch.getStoriesView() || uiManager.getView() == ch.getStoriesViewLs()) {
   		if (isWide) {
			if (uiManager.getView() == ch.getStoriesView()) {
				if (ch.templateMode != 1) {
					lastTopStory = window.pageYOffset;
					uiManager.setView(ch.getStoriesViewLs());
					ch.setCurrentStoryVisible(false);
				}
			}
			getE("mainBody").className="article_landscape";
			//if(getE("frameTop").className=="forceback") getE("frameTop").className="forceback_ls";
        } else {
			if (uiManager.getView() == ch.getStoriesViewLs()) {
				if (ch.templateMode != 1) {
					lastTopStory = window.pageYOffset;
					uiManager.setView(ch.getStoriesView());
					ch.setCurrentStoryVisible(false);
				}
			}
			getE("mainBody").className="article";
			//if(getE("frameTop").className=="forceback_ls") getE("frameTop").className="forceback";
    	}
   } else if (uiManager.getView() == ch.getMainView() || uiManager.getView() == ch.getMainViewLs() || isEmptyView){
		if (isWide) {
			/*bill++*/
			//if (uiManager.getView() == ch.getMainView()) {
			//	lastTopMain = window.pageYOffset;
			//	uiManager.setView(ch.getMainViewLs());
			//	ch.setCurrentMainPageVisible(false);
			//}
			getE("mainBody").className="landscape";
			if(getE("frameTop").className=="forceback") getE("frameTop").className="forceback_ls";
        } else {
			/*bill++*/
			//if (uiManager.getView() == ch.getMainViewLs()) {
			//	lastTopMain = window.pageYOffset;
			//	uiManager.setView(ch.getMainView());
			//	ch.setCurrentMainPageVisible(false);
			//}
			getE("mainBody").className="";
			if(getE("frameTop").className=="forceback_ls") getE("frameTop").className="forceback";
			
		}
		
		if (!isEmptyView) window.scrollTo(0,lastTopMain);
		
		//!!!!!!!!!!!!!!!!!!!!!!!!
		//while(pImg.length) pImg.pop();
		ch.ResumeImagesIfNeeded(100);
		//!!!!!!!!!!!!!!!!!!!!!!!!
			
	}
	
	
	setupDropDown();

}

// Loads widget preferences.
function loadPreferences(){
    if (window.widget) {
        // read feed URL, name and update frequency from the widget settings
        feedURL = widget.preferenceForKey("FeedURL");
        feedName = widget.preferenceForKey("FeedName");
        var feedUpdateFrequencyStr = widget.preferenceForKey("FeedUpdateFrequency");
        feedUpdateFrequency = (feedUpdateFrequencyStr == null) ? -1 : parseInt(feedUpdateFrequencyStr);
    }
    if (feedURL == null) {
        feedURL = feedOptions[0].value;
        feedName = feedOptions[0].text;
        feedUpdateFrequency = feedUpdateFrequencyStatic;
    }
}

function refresh(){
	doOnAnyAction();
	hideAbout();
	hideUpdateNow();
	showVeil();
	showWaiterWithoutFlag();

	channels[currentChannel].refresh();
	showMainView();
	
	
	//new code - copied from chowchannel!------------------------------------------------------------------
	/*dropDownClose();
	hideVeil();
	hideAbout();
	hideUpdateNow();
	showWaiterWithoutFlag();
	var id = currentChannel;
	if (id>=channelCount) id=0;
	currentChannel=id;
	lastTopMain =0;
	lastTopStory =0;
	if (channels[id]==null) {
		channels[id] = new Channel(id,widgetOb);
	}
	var ch = channels[id];
	ch.showMainViewNEWNEWNEW();
	ch.refresh();*/
}

function showStory(i){
	doOnAnyAction();
	channels[currentChannel].showStory(i);
	downloadAd();
}

function homeScreenWidget(i){
    var doc = document;
    if (i == -1) {
    	getE('story_title',doc).innerHTML = "<div style='margin-right:20px'>" + pleaseWaitText + "</div>";
        return;
    }
	var ch = channels[0];
	var ci = ch.getCurrentItems();
	if (ci==null || i >= ci.length) return;

    // do the home screen stuff now
    var help = helper;
	var block = getE('miniViewLoading',doc);
    help.showUsingElement(block, false);
    var ats = ch.getArrayThumbsSrc();
    var at = ch.getArrayThumbs();
    if (ats[i]!=null && at[i]==null) {
    	at[i] = new Image();
    	at[i].name="image_at"+i;
    	at[i].src = ats[i];
    }
    var imageThumb = at[i];
    var doc = document;
    var mipSource = ch.getTimestamps()[i];
    var title = ci[i].title;
    var stitle = title;
    var thumb = doc.getElementById('story_thumb');
    var title1 = doc.getElementById('story_title');
    if ((imageThumb==null) || (imageThumb.src == "")) {
		if (stitle.length > 69) 
			stitle = stitle.substring(0, 69) + "...";
		help.showUsingElement(thumb, false);
		if(rtol) title1.style.right = '2px';
		else title1.style.left = '2px';
		
		title1.style.width = '280px';
	} else {
		thumb.innerHTML = "<img class='story_thumb_img_element' src='" + imageThumb.src + "'  border='0' alt='' />";
		if (stitle.length > 54) 
			stitle = stitle.substring(0, 54) + "...";
		thumb.style.width = '70px';
		help.showUsingElement(thumb, true);
		if(rtol) title1.style.right = '72px';
		else title1.style.left = '72px';
		
		title1.style.width = '240px';
		title1.style.marginLeft = '-25px';
	}
    
    var source = getE('story_source',doc);
    var mipSourceText = "<table><tr valign='top'><td>&nbsp;" + mipSource + "</td></tr></table>";
    source.innerHTML = removeGrafix(mipSourceText);
    
   title1.innerHTML = stitle;
   help.showUsingElement(block, true);
}

function removeGrafix(from){
    myregexp = new RegExp('<img[^<>]*src=[^<>]*/>', 'g');
    from = from.replace(myregexp, '');
    return from;
}

function getAdBody(storyNum,ind){
     var buf;
	 if (ind!=0) {
	 	var margins = "margin-top:4px; margin-bottom:4px";
	 	if (ind == 2)
			margins = "margin-top:35px;";
		
	 	buf = "<div style='" + margins + "' id=\"adBox"+storyNum+"_"+ind+"\"></div>";
	 } else {
	 	buf = "<div id=\"adBox"+storyNum+"\"></div>";
	 }
	return  buf ;
}

function getFooter(){
    var buf = "<div class=\"lineBottom\"></div>";
    buf += "<div align=\"center\" style=\"padding-top:16px\"><img border=\"0\" style=\"vertical-align: middle;\"";
    buf += "src=\"imagesnew/ovi-banner-305px-generic.gif\" width=\"305\" height=\"64\" alt=\"\"/ onclick=\"javascript:window.widget.openURL('http://store.ovi.mobi/?cid=ovistore-fw-bac-na-acq-na-ovi-g0-na-1')\"> </div>";
    buf += "<div class=\"spacer\"></div><br/><br/><br/><br/><br/><br/><br/>";
    return buf;
}

function setViewMode(){
	//alert('setviewmode');
    window.menu.hideSoftkeys();
    var lastInMiniView = isInMiniView;
    var help = helper;
    isInMiniView = help.isMiniViewMode();
   
	var size = help.getScreenSize();
	var body = getE("mainBody");
	body.style.height = size.height+"px";
	body.style.width = size.width+"px";   
	
 	if (size.height>size.width) {
		 isWide = false;
	} else {
		 isWide = true;
	}
    if (isInMiniView) {
		// Hide main screen.
        help.show("HeaderContainer", false);
        help.show("FooterContainer", false);
		help.show("TopDimmer", false);
        help.show("BottomDimmer", false);
        hideShareBox();
        help.show("waiter", false);
       
	    // ... and show MiniView.
        help.show("mini_view", true);
		
		try {
			currentChannel = 0;
			var ch = channels[currentChannel];
			var ci = ch.getCurrentItems();
			if (uiManager.getView() != emptyView) uiManager.setView(emptyView);
			if (ci && ch.getCurrentStory() < ci.length) homeScreenWidget(0);
			if (!isWidget) {
				for (var i = 0; i < channels.length; i++) {
					if (channels[i] != null && channels[i].feedUpdateTime == -1) 
						channels[i].feedUpdateTime = 0;
				}
				isWidget = true;
			}
			
			running = true;
			for (var i = 0; i < channels.length; i++) {
				if (channels[i] != null) 
					channels[i].clearImages();
			}
			var doc = document;
			var ims = doc.images;
			var length = ims.length;
			for (var i = 0; i < length; i++) {
				if (ims[i].name != null) {
					if (ims[i].name.indexOf('image_ai') != -1) {
						ims[i].src = "#";
					}
					else 
						if (ims[i].height == null || ims[i].height < 1) {
							var toDelete = ims[i];
							if (toDelete.src != null) {
								ims[i] = new Image();
								if (toDelete.name) 
									ims[i].name = toDelete.name;
								ims[i].src = toDelete.src;
							}
							toDelete.src = "#";
						}
				}
			}
		}catch(error){}
     }
    else {
    	running = false;
		
		help.show("mini_view", false);
		// ... and show main screen.
		help.show("TopDimmer", true);
		help.show("BottomDimmer", true);
		help.show("HeaderContainer", true);
		help.show("FooterContainer", true);
		
		try {
			var doc = document;
			var ims = doc.images;
			var length = ims.length;
			for (var i = 0; i < length; i++) {
				if (ims[i].name != null && ims[i].height == null || ims[i].height < 1) {
					var toDelete = ims[i];
					if (toDelete.src != null) {
						ims[i] = new Image();
						if (toDelete.name) 
							ims[i].name = toDelete.name;
						ims[i].src = toDelete.src;
					}
					toDelete.src = "#";
				}
			}
			
			// Hide MiniView.
			if (uiManager != null) {
				if (lastInMiniView == true) {
					var ch = channels[0];
					ch.setCurrentStoryVisible(true);
					widgetOb.checkOrientation();
					ch.setTitle();
				}
				else {
					var ch = channels[currentChannel];
					var ci = ch.getCurrentItems();
					
					if (uiManager.getView() == null || uiManager.getView() == emptyView) {
						ch.showStoriesView();
						if (ci && ch.getCurrentStory() < ci.length) 
							ch.setCurrentStoryVisible(true);
					}
					else {
						widgetOb.checkOrientation();
					}
					ch.setTitle();
				}
			}
		}catch(error){}
    }
	
	//this is to fix the image not loading bug when switching from full to miniview
	if(lastInMiniView == false && isInMiniView==true)
	{
		homeScreenWidget(ch.getCurrentStory());
	}
}


function showWaiter(channelId){
    if (currentChannel == channelId) {
		showWaiterWithoutFlag();
	}
}
function showWaiterWithoutFlag(){
    if (isInMiniView) return;
	helper.show("waiter",true);
	showVeil('newDimmer');
}

function hideWaiter(channelId){
    if (currentChannel == channelId) helper.show("waiter",false);
	hideVeil();
}

function hideWaiterWithoutFlag(){
    helper.show("waiter",false);
	hideVeil();
}

function runExit(){
    doOnAnyAction();
	window.close();
}


function onResize(){
	//alert('onresize');
	
	if (pTimer) {
		window.clearTimeout(pTimer);
		pTimer = null;
	}
	
    setViewMode();
}

function nextSlide(){
   if(rtol) channels[currentChannel].previousSlide();
   else channels[currentChannel].nextSlide();
   downloadAd();
}

function previousSlide(){
    if(rtol) channels[currentChannel].nextSlide();
	else channels[currentChannel].previousSlide();
	downloadAd();
}

function runHome(){
	doOnAnyAction();
	hideAbout();
	hideUpdateNow();
	showMainView();
}

function showAbout()
{
	hideUpdateNow();
	
	if (rtol)
		getE('headerimageAbout').className = 'rtol';
	
	getE('AboutTitle').innerHTML=mippinTitle;
	getE('AboutPubl').innerHTML=publisher;
	getE('AboutDesc').innerHTML=description;
	getE('AboutUpdateCheck').innerHTML=updatecheck;
	getE('AboutNoUpdate').innerHTML=noupdate;
	getE('AboutVersion').innerHTML='Version '+version.toFixed(1);
	
	var box = getE('AboutScreen');
	if(box!=null) box.style.display='inline';
	
	if(isWide) getE("frameTop").className="forceback_ls";
	else getE("frameTop").className="forceback";
}

function hideAbout()
{
	var box = getE('AboutNoUpdate');
	if(box!=null) box.style.display='none';
	
	var about = getE('AboutScreen');
	if(about!=null)about.style.display='none';
	getE('frameTop').className='';
}

function showShareBox()
{
	var box = getE('sharebox');
	if(box!=null)
	{
		if(rtol) box.className='open_rtol';
		else box.className='open';
		
		showVeil('darkall');
	}
	
}

function hideShareBox()
{
	var box = getE('sharebox');
	if(box!=null)box.className='';
	
	hideVeil();
}

function showUpdateNow()
{
	hideAbout();
	
	hideWaiterWithoutFlag();
	
	if (rtol)
		getE('headerimageUpdate').className = 'rtol';
	
	var box = getE('UpdateNow');
	if(box!=null)box.style.display='inline';
	
	try{
		getE('unTitle').innerHTML=autoUpdateAvailable;
		getE('unPublisher').innerHTML=publisher;
		getE('unInstallNow').innerHTML=autoUpdateInstall;
		getE('unCheckbox').innerHTML= "<span style='color:#000'>" + autoUpdateNoMore + "</span>";
		getE('unYesBtn').innerHTML=autoUpdateInstallYes;
		getE('unNoBtn').innerHTML=autoUpdateInstallNo;
		
		var box = getE('UpdateNow');
		if (box != null) {
			if (rtol) {
				box.className = 'show_rtol';
			}
			else {
				box.className = 'show';
			}
		}
	
		if(isWide) getE("frameTop").className="forceback_ls";
		else getE("frameTop").className="forceback";
	
		getE('unTitle').innerHTML=updateAvailable;
		if(appUpdateVer !=null) getE('unVersion').innerHTML='v'+appUpdateVer;
		
	}catch(err){}
}

function hideUpdateNow()
{
	var box = getE('UpdateNow');
	if(box!=null)box.style.display='none';
	getE('frameTop').className='';
}

function unToggleCheck(){
	var box = getE('unCheckbox');
	if (box != null) {
		var isChecked = (box.className.match('checked'));
		if (isChecked) box.className = '';
		else box.className = 'checked';
	}
}

//Goto the update URL discovered in the app update check
function unCheckYesBtn()
{
	//goto url stored
	if (appUpdateUrl != null) {
		window.widget.openURL(appUpdateUrl);
		runExit();
	}
}

function unCheckNoBtn()
{
	//store value if checked
	var box = getE('unCheckbox');
	if (box != null) {
		var isChecked = (box.className.match('checked'));
		if(isChecked) window.widget.setPreferenceForKey('1', 'stop_update_checks');
	}

	hideUpdateNow();
	initContinue();
}

function showVeil(style){
	if(style==null) style='light';
	getE('veil').className=style;
}

function hideVeil(){
	getE('veil').className='';
}

function initWidget(){
   var ch = channels[0];
   var ci = ch.getCurrentItems();
   uiManager.setView(emptyView);
	running=true;
	if ((ci==null) || ci.length == 0) { // its the 1st time ever
        homeScreenWidget(-1);
    }
    else 
        homeScreenWidget(0);
  setViewMode();
		
}

function showNoti(text,time)
{
    var ele=getE('NotificationPopup');
	if (ele) {
		if (window.innerWidth > 360) {
			if (ele.style) {
				ele.style.top = "120px";
				ele.style.left = "210px";
			}
		} else {
			if (ele.style) {
				ele.style.top = "220px";
				ele.style.left = "45px";
			}
		}
	}
	getE('NotificationPopupText').innerHTML=text;
	ele.style.display="";
	setTimeout(hideNoti, time);
}

function hideNoti(){
    helper.show("NotificationPopup",false);
}


function shareApp(){
	doOnAnyAction();
	channels[currentChannel].shareApp();
}

function sendSMS(){
	doOnAnyAction();
	channels[currentChannel].sendSMS();
}

function sendEmail(){
	doOnAnyAction();
	channels[currentChannel].sendEmail();
}

function sendTwitter(){
	doOnAnyAction();
	channels[currentChannel].sendTwitter();
}

function sendFacebook(){
	doOnAnyAction();
	channels[currentChannel].sendFacebook();
}

function setFeedItemsForChannel(id,items){
	channels[id].setFeedItems(items,true);
}

function saveAllCurrentItemsForChannel(id){
	channels[id].saveAllCurrentItems();
}

function doAd(isMain, ind) 
{
	if (adsHTML==null || adsHTML.length==0) return;
	var adHTML=adsHTML[0];
	if ((adHTML==null) || (adHTML == "")) return;
	//console.log("ad: (" + adHTML + ")");
	var doc = document;
	if (isMain) {
		var ele = getE('adBoxmain_1',doc);
		if (ele) ele.innerHTML="<div style=\"height:5px;\"></div>"+adHTML+"<div class=\"lineBottom\"></div>";
		ele = getE('adBoxmain_2',doc);
		if (ele) ele.innerHTML="<div class=\"lineBottom\" style='margin-bottom:10px'></div>"+adHTML+"<div style=\"height:5px;\"></div>";
	}

	if (ind!=null) {
		ele = getE('adBox'+ind+"_"+1,doc);
		if (ele) ele.innerHTML="<div style=\"height:5px;\"></div>"+adHTML+"<div class=\"lineBottom\"></div>";
		ele = getE('adBox'+ind+"_"+2,doc);
		if (ele) ele.innerHTML="<div class=\"lineBottom\" style='margin-bottom:10px'></div>"+adHTML+"<div style=\"height:5px;\"></div>";
	}
}

function downloadAd() {
	if (adnum==0) return;
	var now = new Date().getTime();
	if ((now - lastAdDownload)< 60000) return;
	setTimeout(doDownloadAd,100);
}

function doDownloadAd(){
	if (adUpdate!=null && adUpdateStart!=0 && adUpdateStart<(new Date().getTime()-300000)) adUpdate = null;
	if (adUpdate == null && adnum>0) {
		adUpdate = new MippinUpdate();
		adUpdateStart = new Date().getTime();
		adUpdate.fetchAds(adUrl + adnum, adUpdateCompleted);
	}
}

function adUpdateCompleted(event) {
	 if (event.status == "ok") {
        adsHTML=[];
		for (var i=0;i<event.advertHTMLs.length;i++) {
			adsHTML[i] = event.advertHTMLs[i];
		}
		doAd(true,null);

    } else {
		adnum=0;
		adsHTML=[];
    }
    
    // null the broker reference to indicate that there's no current
    // update in progress
    adUpdate = null;
	lastAdDownload = new Date().getTime();
}

//isAuto - means we're doing an 
function versionCheck(isAuto) {
	setTimeout('doVersionCheck('+isAuto+')',100);
}

function doVersionCheck(isAuto){
	if (verChecker == null) {
		verChecker = new AppVersionCheck();
		if(isAuto) verChecker.versionCheck(autoVerCheckCompleted);
		else verChecker.versionCheck(verCheckCompleted);
	}
}

function verCheckCompleted(event) {
	if (event.status == "ok") {
		var updateUrl = event.downloadUrl;
		showUpdateAvailable(true, updateUrl);
    }else
	{
		showUpdateAvailable(false);
	}
    verChecker = null;
}

function autoVerCheckCompleted(event) {
	if (event.status == "ok") {
		appUpdateUrl = event.downloadUrl;
		appUpdateVer = event.dlVersion;
		showUpdateNow();
    }else
	{
		initContinue();
	}
    // null the broker reference to indicate that there's no current
    verChecker = null;
}

function showUpdateAvailable(isAvailable, updateUrl)
{
	if(isAvailable)
	{
		window.widget.openURL(updateUrl);
		runExit();
		//window.location.href=updateUrl;
	}else
	{
		getE('AboutNoUpdate').style.display='block';
	}
} 

function getValueForWidget(key){
		var value =window.widget.preferenceForKey(key);
		if (value) return value.split("t3k_89");
		return null;
}

function setChannels(newChannelCount,newChannelTitles){
	   var doCheck = false;
	   var win = window.widget;
	   if (channelCount!=newChannelCount) doCheck = true;
	   var length = newChannelTitles.length;
	   for (var i=0; i<length;i++){
	   		win.setPreferenceForKey(newChannelTitles[i], "channel_title_"+i); 
	   }
	   win.setPreferenceForKey(newChannelCount, "channel_count"); 
	   channelCount = newChannelCount;
	   channelTitles = newChannelTitles;
	   if (doCheck) widgetOb.checkOrientation();
}

function setupChannels(){
	   var win = window.widget;
	   var length = win.preferenceForKey("channel_count"); 
	   var channT=[];
	   if (length==null || length==0) return;
	   for (var i = 0; i < length; i++) {
	   		channT.push(win.preferenceForKey("channel_title_"+i));
	   }
	   channelCount = length;
	   channelTitles = channT;
}

function getTextForTimestamp(item){
	if (item.mipSource!=null) {
		 var minutesDiff = parseInt(item.mipSource/60000);
		 var hours = parseInt(minutesDiff/60);
		 var days = parseInt(hours/24);
		 var months = parseInt(days/30);
		 var years = parseInt(days/365);
		 minutesDiff = minutesDiff - (hours*60);
		 var timeString = "";
		 if(years>0)
		 {
			 timeString = (years>1? yearPlural:yearSingle).replace("{number}",years);
		 }else if(months >0)
		 {
			 timeString = (months>1? monthPlural:monthSingle).replace("{number}",months);
		 }else if(days >0)
		 {
			 timeString = (days>1? dayPlural:daySingle).replace("{number}",days);
		 }else if(hours >0)
		 {
			 timeString = (hours>1? hourPlural:hourSingle).replace("{number}",hours);
		 }else //do minutes
		 {
			 if(minutesDiff == 0) timeString = justPublished;
			 else timeString =(minutesDiff>1? minutePlural:minuteSingle).replace("{number}",minutesDiff);
		 }
		 
		 return timeString;
	} else return '';
}

function landscapeToggle(isLandscape){
	
	doOnAnyAction();
	
	var body = getE('mainBody');
	if (body != null) {
		var isArticle = (body.className.match('article'));
		if (isLandscape) {
			if(isArticle) body.className = 'article_landscape';
			else body.className = 'landscape';
		}
		else {
			if(isArticle) body.className = 'article';
			else body.className = '';
		}
	}
}

//drop down toggle
function setupDropDown()
{
	var dropDownMenu = getE('dropDownMenu');
	var dropDownMenuBg = getE('dropDownMenuBg');
	if (channelCount > 1) {
		dropDownMenuBg.className = 'multiChannelBg';
		dropDownMenu.className = 'closedd';
	}
	else {
		dropDownMenuBg.className = 'singleChannelNoBg';
		dropDownMenu.className = 'refresh';
	}
}


function toggleGalleryDescriptionBar() {
	var d = document.getElementsByClassName('galleryImageArticleTextContainerBottom');
	
	var i = 0;
	for (i =0; i<d.length; i++) {
		if ((typeof d[i]  == "undefined") || (typeof d[i].className  == "undefined" ))
			continue;
		if (d[i].className.match(' maximized'))
			d[i].className = d[i].className.replace(' maximized', ' minimized');
		else
			d[i].className = d[i].className.replace(' minimized', ' maximized');
	}
}


//drop down toggle
function dropDownToggle(){

	if (channelCount <= 1)
	{
		refresh();
		return;
	}
	 
	var dropDownMenu = getE('dropDownMenu');
	var HeaderContainer = getE('HeaderContainer');
	var itemList = getE('itemList');
	
	var tmpRtol = "";
	if (HeaderContainer.className == 'rtol') {
		tmpRtol = "_rtol";
	}
	
	if (dropDownMenu.className=='open') {
		dropDownMenu.className='closedd';
		hideVeil();
	} else if (dropDownMenu.className=='closedd') {
		try {
			itemList.className = 'open' + channelCount + tmpRtol;
		}
		catch (err) {}
		dropDownMenu.className='open';
		showVeil('newDimmer');
	}
}

function dropDownClose(){setupDropDown();}

function showChannel(id){
	dropDownClose();
	/*bill*/
	hideVeil();
	hideAbout();
	hideUpdateNow();
	if (currentChannel == id) {
		lastTopMain =0;
		lastTopStory =0;
		channels[currentChannel].showMainView();
		if (channels[currentChannel].isUpdating) showWaiter(currentChannel);
		else hideWaiter(currentChannel);
		return;
	}
	if (id>=channelCount) id=0;
	currentChannel=id;
	lastTopMain =0;
	lastTopStory =0;
	if (channels[id]==null) {
		channels[id] = new Channel(id,widgetOb);
	}
	var ch = channels[id];
	ch.showMainView();
	ch.updateContent();
	downloadAd();
}
function showMainView(){
	channels[currentChannel].showMainView();
	downloadAd();
}

function getE(elename, doc)
{
	if(doc==null) return document.getElementById(elename);
	else return doc.getElementById(elename);
}







document.getElementsByClassName = function(cl) {
	var retnode = [];
	var myclass = new RegExp('\\b'+cl+'\\b');
	var elem = this.getElementsByTagName('*');
	for (var i = 0; i < elem.length; i++) {
	var classes = elem[i].className;
	if (myclass.test(classes)) retnode.push(elem[i]);
	}
	return retnode;
}; 



function OviBarHTMLcode() {
	return "\
		<div class='oviBar'>\
			<a href='#' onclick=\"javascript:widget.openURL('http://appwizard.ovi.com/info/')\"><div class='oviBarLink'>" + createdWith + " Ovi app wizard</div><a/>\
			<a href='#' onclick='javascript:showAbout();'><div class='whiteLink' style='float:right; height:45px; width:55px; position:relative; top:-10px; margin-left:25px;'></div>\
		</div>";
}

function HeaderImageHTML() {
	return "\
                <div id='headerimage'>\
                    <img src='shared/logo32.gif' alt='' height='60' border='0' />\
                </div>";
}













